<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: PCF8574 Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classPCF8574-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">PCF8574 Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Encapsulate a PCF8574 device.  
 <a href="classPCF8574.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="PCF8574_8h_source.html">PCF8574.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ad0d39528381767afa84080f3687d69ca"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPCF8574.html#ad0d39528381767afa84080f3687d69ca">PCF8574</a> (uint8_t address)</td></tr>
<tr class="memdesc:ad0d39528381767afa84080f3687d69ca"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class constructor.  <a href="#ad0d39528381767afa84080f3687d69ca">More...</a><br /></td></tr>
<tr class="separator:ad0d39528381767afa84080f3687d69ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a20ddebfc28ba46646ca84f8c75034b34"><td class="memItemLeft" align="right" valign="top"><a id="a20ddebfc28ba46646ca84f8c75034b34"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPCF8574.html#a20ddebfc28ba46646ca84f8c75034b34">~PCF8574</a> ()</td></tr>
<tr class="memdesc:a20ddebfc28ba46646ca84f8c75034b34"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class instance destructor. <br /></td></tr>
<tr class="separator:a20ddebfc28ba46646ca84f8c75034b34"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abfe627fd97523863fa0075422b0158b6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPCF8574.html#abfe627fd97523863fa0075422b0158b6">init</a> (gpio_num_t sdaPin=<a class="el" href="classI2C.html#a4d371d14b0fcae3b20f22ee8254536b8">I2C::DEFAULT_SDA_PIN</a>, gpio_num_t clkPin=<a class="el" href="classI2C.html#aece11572688a31925150176f2241e956">I2C::DEFAULT_CLK_PIN</a>)</td></tr>
<tr class="memdesc:abfe627fd97523863fa0075422b0158b6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the <a class="el" href="classPCF8574.html" title="Encapsulate a PCF8574 device.">PCF8574</a> device.  <a href="#abfe627fd97523863fa0075422b0158b6">More...</a><br /></td></tr>
<tr class="separator:abfe627fd97523863fa0075422b0158b6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a90a8a8c48e0530c7371dacabc1f6a282"><td class="memItemLeft" align="right" valign="top">uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPCF8574.html#a90a8a8c48e0530c7371dacabc1f6a282">read</a> ()</td></tr>
<tr class="memdesc:a90a8a8c48e0530c7371dacabc1f6a282"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read all the input bits from the device.  <a href="#a90a8a8c48e0530c7371dacabc1f6a282">More...</a><br /></td></tr>
<tr class="separator:a90a8a8c48e0530c7371dacabc1f6a282"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4e484981cdf6451bb36a13f9d3a60400"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPCF8574.html#a4e484981cdf6451bb36a13f9d3a60400">readBit</a> (uint8_t bit)</td></tr>
<tr class="memdesc:a4e484981cdf6451bb36a13f9d3a60400"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read the logic level on a given pin.  <a href="#a4e484981cdf6451bb36a13f9d3a60400">More...</a><br /></td></tr>
<tr class="separator:a4e484981cdf6451bb36a13f9d3a60400"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9663079a19f252a5edc2471f384bc28b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPCF8574.html#a9663079a19f252a5edc2471f384bc28b">setInvert</a> (bool value)</td></tr>
<tr class="memdesc:a9663079a19f252a5edc2471f384bc28b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Invert the bit values. Normally setting a pin's value to 1 means that a high signal is generated and a 0 means a low signal is generated. Setting the inversion to true, inverts that meaning.  <a href="#a9663079a19f252a5edc2471f384bc28b">More...</a><br /></td></tr>
<tr class="separator:a9663079a19f252a5edc2471f384bc28b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d51dcc9e396c431561b8a0b044a9e6b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPCF8574.html#a5d51dcc9e396c431561b8a0b044a9e6b">write</a> (uint8_t value)</td></tr>
<tr class="memdesc:a5d51dcc9e396c431561b8a0b044a9e6b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the output values of the device.  <a href="#a5d51dcc9e396c431561b8a0b044a9e6b">More...</a><br /></td></tr>
<tr class="separator:a5d51dcc9e396c431561b8a0b044a9e6b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0d2f2b79548651b4fc40faefdc7156b0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPCF8574.html#a0d2f2b79548651b4fc40faefdc7156b0">writeBit</a> (uint8_t bit, bool value)</td></tr>
<tr class="memdesc:a0d2f2b79548651b4fc40faefdc7156b0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Change the output value of a specific pin.  <a href="#a0d2f2b79548651b4fc40faefdc7156b0">More...</a><br /></td></tr>
<tr class="separator:a0d2f2b79548651b4fc40faefdc7156b0"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Encapsulate a PCF8574 device. </p>
<p>The PCF8574 is a 8 bit GPIO expander attached to I2C. It can read and write 8 bits of data and hence has 8 pins that can be used for input or output.</p>
<dl class="section see"><dt>See also</dt><dd><a href="http://www.ti.com/product/PCF8574">PCF8574 home page</a> </dd></dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ad0d39528381767afa84080f3687d69ca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad0d39528381767afa84080f3687d69ca">&#9670;&nbsp;</a></span>PCF8574()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PCF8574::PCF8574 </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>address</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Class constructor. </p>
<p>The address is the address of the device on the I2C bus. This is the value 0x20 plus the value of the device input pins <code>A0</code>, <code>A1</code> and <code>A2</code>. This means that the address should be between 0x20 and 0x27.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">address</td><td>The I2C address of the device on the I2C bus. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="abfe627fd97523863fa0075422b0158b6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abfe627fd97523863fa0075422b0158b6">&#9670;&nbsp;</a></span>init()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PCF8574::init </td>
          <td>(</td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>sdaPin</em> = <code><a class="el" href="classI2C.html#a4d371d14b0fcae3b20f22ee8254536b8">I2C::DEFAULT_SDA_PIN</a></code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>clkPin</em> = <code><a class="el" href="classI2C.html#aece11572688a31925150176f2241e956">I2C::DEFAULT_CLK_PIN</a></code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Initialize the <a class="el" href="classPCF8574.html" title="Encapsulate a PCF8574 device.">PCF8574</a> device. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">sdaPin</td><td>The pin to use for the I2C SDA functions. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">clkPin</td><td>The pin to use for the I2C CLK functions. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a90a8a8c48e0530c7371dacabc1f6a282"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a90a8a8c48e0530c7371dacabc1f6a282">&#9670;&nbsp;</a></span>read()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint8_t PCF8574::read </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Read all the input bits from the device. </p>
<dl class="section return"><dt>Returns</dt><dd>An 8 bit value representing the values on each of the input pins. </dd></dl>

</div>
</div>
<a id="a4e484981cdf6451bb36a13f9d3a60400"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4e484981cdf6451bb36a13f9d3a60400">&#9670;&nbsp;</a></span>readBit()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool PCF8574::readBit </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>bit</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Read the logic level on a given pin. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">bit</td><td>The input pin of the device to read. Values are 0-7. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True if the pin is high, false otherwise. Undefined if there is no signal on the pin. </dd></dl>

</div>
</div>
<a id="a9663079a19f252a5edc2471f384bc28b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9663079a19f252a5edc2471f384bc28b">&#9670;&nbsp;</a></span>setInvert()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PCF8574::setInvert </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Invert the bit values. Normally setting a pin's value to 1 means that a high signal is generated and a 0 means a low signal is generated. Setting the inversion to true, inverts that meaning. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">value</td><td>True if we wish to invert the signals and false otherwise. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a5d51dcc9e396c431561b8a0b044a9e6b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5d51dcc9e396c431561b8a0b044a9e6b">&#9670;&nbsp;</a></span>write()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PCF8574::write </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the output values of the device. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">value</td><td>The bit pattern to set on the output. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a0d2f2b79548651b4fc40faefdc7156b0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0d2f2b79548651b4fc40faefdc7156b0">&#9670;&nbsp;</a></span>writeBit()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PCF8574::writeBit </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>bit</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Change the output value of a specific pin. </p>
<p>The other bits beyond the one setting retain their values from the previous call to <a class="el" href="classPCF8574.html#a5d51dcc9e396c431561b8a0b044a9e6b" title="Set the output values of the device.">write()</a> or previous calls to <a class="el" href="classPCF8574.html#a0d2f2b79548651b4fc40faefdc7156b0" title="Change the output value of a specific pin.">writeBit()</a>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">bit</td><td>The pin to have its value changed. The pin may be 0-7. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">value</td><td>The logic level to appear on the identified output pin. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="PCF8574_8h_source.html">PCF8574.h</a></li>
<li>PCF8574.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
